=== debian/changelog ===
coccinelle (1.0.0~rc9.deb-1ubuntu1) precise; urgency=low

  * Merge from Debian testing.  Remaining changes:
    - Add Pre-Depends on dpkg >= 1.15.6 for xz deb compression, this is needed
      until after the 12.04 LTS

 -- Micah Gersten <micahg@ubuntu.com>  Thu, 26 Jan 2012 18:05:11 -0600

coccinelle (1.0.0~rc9.deb-1) unstable; urgency=low

  * New upstream RC
  * Updated patches:
    - pycaml-build-check.diff

 -- Євгеній Мещеряков <eugen@debian.org>  Sat, 14 Jan 2012 21:41:43 +0100

coccinelle (1.0.0~rc7.deb-6) unstable; urgency=low

  * Build-depend on dh-ocaml >= 1.0.3~ and add --parallel to dh options
    instead of dh_auto_build

 -- Євгеній Мещеряков <eugen@debian.org>  Wed, 14 Dec 2011 01:34:05 +0100

coccinelle (1.0.0~rc7.deb-5ubuntu2) precise; urgency=low

  * Use >=1.15.6 for the dpkg Pre-Depends as the fix to use a backported dpkg
    hasn't landed in LP yet
    - update debian/control 

 -- Micah Gersten <micahg@ubuntu.com>  Tue, 20 Dec 2011 22:17:56 -0600
