=== debian/changelog ===
coccinelle (1.0.0~rc10.deb-1ubuntu1) precise; urgency=low

  * Merge from Debian unstable. (FFe: LP: #939282) Remaining changes:
    - Add Pre-Depends on dpkg >= 1.15.6 for xz deb compression, this is needed
      until after the 12.04 LTS
  * Fixes FTBFS from rebuild (LP: #935056)

 -- Micah Gersten <micahg@ubuntu.com>  Thu, 23 Feb 2012 03:12:03 -0600

coccinelle (1.0.0~rc10.deb-1) unstable; urgency=low

  * New upstream RC
  * Update debian/watch

 -- Євгеній Мещеряков <eugen@debian.org>  Tue, 21 Feb 2012 22:25:26 +0100
